clc;
clear;
close all;
% compute the inverse z-transform of:
% X(z) = 1 /[(1 − 0.9z^(−1)]^2 [(1 + 0.9z^(−1))] , |z| > 0.9)
% X(z) = B(z^(-1))/A(z^(-1))
B =[1];
A=poly([0.9, 0.9, -0.9])% nous donne A = [1.0000   -0.9000   -0.8100    0.7290]...
                                     %donc le polynome s'écrit: 
                                     %1-0.9z^(-1)-0.81z^(-2)-0.7290z^(-3)
[R, p, K]=residuez(B,A)

% Autre methode
b0=1;
a1=[1, -0.9];
a2=[1, 0.9];
b=b0;
a=conv(conv(a1,a1),a2);
[R, p, K]=residuez(b,a)
% Trouvons x(n) i.e Transformation inverse en z de X(z) à partir de R et p
% et k . R =[0.2500 ,0.2500 ,0.5000] p = [-0.9000, 0.9000, 0.9000] et k=[]
% donc X(z)=  0.25/(1 + 0.9z^(−1))+0.25/(1 − 0.9z^(−1)) + 0.5/(1 − 0.9z^(−1))2 , |z| > 0.9
% avec le tableau usuel de TZ on peut trouvez
% x(n) = 0.25(0.9)^(n)u(n) + 5/9 (n + 1)(0.9)^(n+1)u(n + 1) + 0.25 (−0.9)^(n)u(n)

%%
%Numeriquement on peut trouvex x(n) à partir de X(z) en utilisant la
%reponse impulsionnelle delta en utilsant la fonction filtre 

[delta,n] =impseq(0,0,7) % pour 8 echant n=[0:7]
x=filter(b,a,delta)
subplot(2,1,1); stem(n,x); title('Output sequence')
%%
%Analytiquemet
un = stepseq(0,0,7) %u(n)
un_1 = stepseq(-1,0,7) % u(n+1)

x_n = 0.25.*(0.9).^n.*un + 5/9.*(n + 1).*(0.9).^(n+1).*un_1 + 0.25.*(-0.9).^(n).*un
subplot(2,1,2); stem(n,x_n); title('Output step')

